laps = telemetry.getAllLaps()
for (let i = 0; i < laps.length; i++)
{
    let lap = laps[i]
    let speed = lap.channel("speed")
    let lfspeed =  lap.channel("lfspeed")
    let rfspeed =  lap.channel("rfspeed")
    let lrspeed =  lap.channel("lrspeed")
    let rrspeed =  lap.channel("rrspeed")
    
    if (!lfspeed || !rfspeed || !lrspeed || !rrspeed)
        continue

    let lflock =  lap.editChannel("lflock")
    let rflock =  lap.editChannel("rflock")
    let lrlock =  lap.editChannel("lrlock")
    let rrlock =  lap.editChannel("rrlock")

    for (let j = 0; j < speed.length; j++)
    {
        if (speed.value(j) < 1)
        {
            lflock.setValue(j, 0);
            rflock.setValue(j, 0);
            lrlock.setValue(j, 0); 
            rrlock.setValue(j, 0); 
        }
        else 
        {
            lflock.setValue(j, 1 - Math.min(lfspeed.value(j) / speed.value(j), 1));
            rflock.setValue(j, 1 - Math.min(rfspeed.value(j) / speed.value(j), 1));
            lrlock.setValue(j, 1 - Math.min(lrspeed.value(j) / speed.value(j), 1)); 
            rrlock.setValue(j, 1 - Math.min(rrspeed.value(j) / speed.value(j), 1));
        }
    }
}